## llvm-toolchain-19 19.1.2

=== debian/changelog ===
llvm-toolchain-19 (1:19.1.2-2) unstable; urgency=medium

  [ Samuel Thibault ]
  * Disable time64_t ABI on hurd-i386 too.

  [ Sylvestre Ledru ]
  * Use the | hello trick for g++-multilib for s390x / Ubuntu Oracular
  * Enable compiler-rt runtime again for 32bit time_t64 architectures.
    (Closes: #1085853)
  * Backport Ubuntu 25.04 - Plucky Puffin support

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 27 Oct 2024 21:05:41 +0100

llvm-toolchain-19 (1:19.1.2-1) unstable; urgency=medium

  [ Samuel Thibault ]
  * patches/hurd/hurd-f_type.diff: Fix hurd build against glibc ≥ 2.39.
  * libomp-X.Y-dev.install.in: Don't try to ship ompd gdb plugin on
    hurd-amd64 ; ship libomptarget.
  * libomp5-X.Y.install.in: Ship libomptarget.
  * libomp5-X.Y.symbols.in: Fix symbols on hurd-any.
  * rules: Fix syntax on non-linux.

  [ John Paul Adrian Glaubitz ]
  * Don't try to install xray and profile headers on powerpc

  [ Sylvestre Ledru ]
  * New release
  * Update Standards version to 4.7.0

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 15 Oct 2024 15:11:47 +0200

=== debian/control ===
Source: llvm-toolchain-19
Section: devel
Priority: optional
Rules-Requires-Root: no
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>, Gianfranco Costamagna <locutusofborg@debian.org>
Build-Depends: debhelper (>= 10.0), cmake, ninja-build,
    chrpath, texinfo, sharutils,
    libelf-dev,
    libffi-dev,
    lsb-release, patchutils, diffstat, xz-utils, python3-dev,
    libedit-dev, libncurses-dev, swig, python3-sphinx (>= 1.3.6),
    binutils-dev,
    libxml2-dev,
    libjsoncpp-dev, pkg-config,
    libipt-dev [amd64 i386],
    lcov, procps, help2man,
    zlib1g-dev, libzstd-dev,
    g++-multilib [amd64 i386 mips64 mips64el mipsel powerpc ppc64 s390x sparc sparc64 x32] | hello,
    libjs-mathjax, python3-myst-parser | python3-recommonmark, python3-pexpect,
    doxygen, time,
    ocaml-base [amd64 arm64 ppc64el riscv64 s390x] | ocaml-nox [amd64 arm64 ppc64el riscv64 s390x],
    ocaml-findlib [amd64 arm64 ppc64el riscv64 s390x],
    libctypes-ocaml-dev [amd64 arm64 ppc64el riscv64 s390x],
    dh-exec, dh-ocaml [amd64 arm64 ppc64el riscv64 s390x],
    libpfm4-dev [linux-any], python3-setuptools, libz3-dev [!sh4],
# "| hello" is for older buster/bionic distros without spirv support
# We need to keep the constraints coherent between the two alternatives, otherwise
# hello would get installed unexpectedly and prevent e.g. wasi-libc from getting pulled
    llvm-spirv-19 [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1> | hello [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
    spirv-tools [linux-any] <!stage1> | hello [linux-any] <!stage1>,
    wasi-libc | hello,
    libcurl4-openssl-dev <!stage1> | libcurl-dev <!stage1>,
    libgrpc++-dev [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x] <!stage1>,
    protobuf-compiler-grpc [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x] <!stage1>,
    libprotobuf-dev [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x] <!stage1>,
    protobuf-compiler [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x] <!stage1>,
Build-Conflicts: oprofile
Standards-Version: 4.7.0
Homepage: https://www.llvm.org/
Vcs-Git: https://salsa.debian.org/pkg-llvm-team/llvm-toolchain.git -b 19
Vcs-Browser: https://salsa.debian.org/pkg-llvm-team/llvm-toolchain/tree/19

# ------------- clang -------------

Package: clang-19
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 ${dep:devlibs-objc},
 libllvm19 (= ${binary:Version}),
 libclang-common-19-dev (= ${binary:Version}),
 llvm-19-linker-tools (= ${binary:Version}),
 libclang1-19 (= ${binary:Version}), libc6-dev, binutils
Provides: c-compiler, objc-compiler, c++-compiler, objc++-compiler
Recommends: llvm-19-dev, python3
# libomp-19-dev
Suggests: clang-19-doc, wasi-libc
Description: C, C++ and Objective-C compiler
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.

Package: clang-tools-19
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, clang-19 (= ${binary:Version}),
 python3
Description: clang-based tools for C/C++ developments
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains some clang-based tools like scan-build, clang-cl, etc.

Package: clang-format-19
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
 libllvm19 (= ${binary:Version})
Description: Tool to format C/C++/Obj-C code
 Clang-format is both a library and a stand-alone tool with the goal of
 automatically reformatting C++ sources files according to configurable
 style guides. To do so, clang-format uses Clang's Lexer to transform an
 input file into a token stream and then changes all the whitespace around
 those tokens. The goal is for clang-format to both serve both as a user
 tool (ideally with powerful IDE integrations) and part of other
 refactoring tools, e.g. to do a reformatting of all the lines changed
 during a renaming.
 .
 This package also provides vim and emacs plugins.

Package: clang-tidy-19
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
 libllvm19 (= ${binary:Version}),
 libclang-common-19-dev (= ${binary:Version}),
 clang-tools-19, python3-yaml
Description: clang-based C++ linter tool
 Provide an extensible framework for diagnosing and fixing typical programming
 errors, like style violations, interface misuse, or bugs that can be deduced
 via static analysis. clang-tidy is modular and provides a convenient interface
 for writing new checks.

Package: clangd-19
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libllvm19 (= ${binary:Version}),
 libclang-common-19-dev (= ${binary:Version}),
Description: Language server that provides IDE-like features to editors
 clangd understands your C++ code and adds smart features to your editor:
  - code completion
  - compile errors
  - go-to-definition
  - and more.
 .
 clangd is a language server that implements the Language Server Protocol;
 it can work with many editors through a plugin.

Package: clang-19-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-mathjax
Description: C, C++ and Objective-C compiler - Documentation
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the documentation.

Package: libclang1-19
Provides: ${t64:Provides}
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang library.
 .
 The C Interface to Clang provides a relatively small API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.

Package: libclang-19-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 ${dep:devlibs-objc}, libclang1-19 (= ${binary:Version}),
 libclang-common-19-dev (= ${binary:Version})
Description: Clang library - Development package
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang headers to develop extensions over
 libclang1-19.

Package: libclang-common-19-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends},
Recommends: libclang-rt-19-dev
Description: Clang library - Common development package
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang generic headers.

# ------------- compiler-rt -------------

Package: libclang-rt-19-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Compiler-rt - development package
 This package provides various libraries:
 .
   * builtins - Simple libraries that provide implementation of the
     low-level target-specific hooks required by code generation
     and other runtime components.
   * sanitizer runtimes - AddressSanitizer, ThreadSanitizer,
     UndefinedBehaviorSanitizer, MemorySanitizer, LeakSanitizer
     DataFlowSanitizer, etc
   * profile - Library which is used to collect coverage information.

Package: libclang-rt-19-dev-wasm32
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Compiler-rt - wasm32 builtins
 Provides the compiler-rt builtins for WebAssembly 32 bits

Package: libclang-rt-19-dev-wasm64
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Compiler-rt - wasm64 builtins
 Provides the compiler-rt builtins for WebAssembly 64 bits

# ------------- polly -------------

Package: libpolly-19-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: High-level loop and data-locality optimizer
 Uses an abstract mathematical representation based on integer polyhedra
 to analyze and optimize the memory access pattern of a program

# ------------- clang libraries -------------

Package: libclang-cpp19
Provides: ${t64:Provides}
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libllvm19 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: C++ interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang C++ library.
 .
 The C++ Interface to Clang provides an API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.

Package: libclang-cpp19-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 libclang-cpp19 (= ${binary:Version})
# Move of libclang-cpp.so into libclang-cpp19.dev
Description: C++ interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang C++ library.
 .
 The C++ Interface to Clang provides an API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.
 .
 This package contains symlinks without a version number, which needed by
 linker at build time.


Package: libfuzzer-19-dev
Architecture: linux-any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, clang-19 (= ${binary:Version})
Description: Library for coverage-guided fuzz testing
 LibFuzzer is a library for in-process, coverage-guided, evolutionary fuzzing
 of other libraries.
 .

=== debian/rules ===
#!/usr/bin/make -f

# polly & lldb aren't enabled for every platform
PROJECTS = clang;clang-tools-extra;lld;cross-project-tests;mlir
# openmp & libunwind aren't enabled for every platform

TARGET_BUILD	:= build-llvm
TARGET_BUILD_STAGE2    := $(TARGET_BUILD)/tools/clang/stage2-bins
DEB_INST		:= $(CURDIR)/debian/tmp/

GXX_VERSIONED_PACKAGE    := $(shell dpkg-query -W -f '$${Depends}' g++ | grep -o 'g++-[0-9][0-9.]*' | tail -n1 )
GXX_VERSIONED_EXECUTABLE := $(shell dpkg -L $(GXX_VERSIONED_PACKAGE) | grep '/usr/bin/g++-[0-9][0-9.]*' | xargs ls -d | tail -n1 )
GCC_VERSION              := $(subst /usr/bin/g++-,,$(GXX_VERSIONED_EXECUTABLE))

PKG_VERSION := $(shell dpkg-parsechangelog | awk '/^Version:/ {print $$2}')
LLVM_EPOCH := 1:
LLVM_VERSION   := $(shell echo $(PKG_VERSION) | sed -rne "s,^1:([0-9]+).*,\1,p")
LLVM_VERSION_FULL := $(shell echo $(PKG_VERSION) | sed -rne "s,^1:([0-9.]+)(~|-)(.*),\1,p")
LLVM_VERSION_MINOR := $(shell echo $(PKG_VERSION)  | sed -rne "s,^1:[0-9]+\.([0-9]+)\.[0-9]+.*,\1,p")
LLVM_VERSION_SNAPSHOT := $(shell echo $(PKG_VERSION) | sed -rne "s,^1:(.*),\1,p")
ifeq ($(LLVM_VERSION),$(LLVM_VERSION_FULL))
	LLVM_VERSION_FULL := $(LLVM_VERSION).0.0
	LLVM_VERSION_MINOR := 0
endif
LLVM_VERSION_NEXT := $(shell echo $(LLVM_VERSION_FULL) | awk -F. '{ OFS="."; $$NF+=1; print}')

# dpkg-buildflags support
# disable fixfilepath in favor of the llvm-project supplied flavor, disable lto
# remove +time64,+lfs once the time64_t transition starts
ifeq ($(DEB_HOST_ARCH_CPU),i386)
  RUNTIMES = compiler-rt;libcxx;libcxxabi
  export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto
else
  RUNTIMES = compiler-rt;libcxx;libcxxabi
  ifeq ($(DEB_HOST_ARCH_BITS),32)
    export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto abi=+time64,+lfs
  else
    ifeq ($(DEB_HOST_ARCH),mips64el)
        export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto hardening=-stackprotector,-stackprotectorstrong
    else
        export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto
    endif
  endif
endif

SOURCE_NAME := $(shell dpkg-parsechangelog -S Source)
ifneq (,$(findstring snapshot,$(SOURCE_NAME)))
  BRANCH_NAME=snapshot
else
  BRANCH_NAME=$(LLVM_VERSION)
endif

VENDOR=$(shell lsb_release -is)
DISTRO=$(shell lsb_release -sc)
DERIVATIVE := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
		elif dpkg-vendor --derives-from Debian; then echo Debian; \
		else echo Unknown; fi)

SONAME_EXT      := 1
SONAME_OPENMP	:= 5
# Manage the case when the version is 3.5~svn213052-1~exp1 or 3.4.2-1
DEBIAN_REVISION := $(shell dpkg-parsechangelog |  sed -rne "s,^Version: 1:([0-9.]+)(~|-)(.*),\3,p")
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NCPUS := $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
else
  NCPUS := $(shell nproc)
endif

# this contains all packages to be built. Note that for at least the clean target,
# this always includes the binary-indep packages.
packages := $(shell dh_listpackages)

# no 32bit support
FLANG_ARCHS := amd64 arm64 ppc64el ppc64 sparc64 riscv64 loong64

# flang has some memory hogs, of up to 6.2gb per process. Limit the parallel jobs
# based on the available memory
ifneq (,$(filter $(DEB_HOST_ARCH), $(FLANG_ARCHS)))
  MEM_PER_CPU=6000
else
  MEM_PER_CPU=2100
endif
NJOBS := $(shell mt=`awk '/^(MemAvail|SwapFree)/ { mt += $$2 } END {print mt}' /proc/meminfo`; \
		awk -vn=$(NCPUS) -vmt=$$mt -vm=$(MEM_PER_CPU) \
		  'END { mt/=1024; n2 = int(mt/m); print n==1 || n2<=1 ? 1 : n2<=n ? n2 : n }' < /dev/null)

TIME_COMMAND = $(CURDIR)/debian/usage-wrapper.py $(SUMMARY_ONLY) -j $(NJOBS) --base-memory -m 4.0 -o usage-$(notdir $@)-$(DEB_HOST_ARCH).svg
TIME_BIN := $(if $(wildcard /usr/bin/time),/usr/bin/time,/bin/time)
TIME_COMMAND = $(TIME_BIN) -v
USAGE_BUILD_DEP = $(EMPTY) time,
ifneq (,$(findstring usage-wrapper, $(TIME_COMMAND)))
  ifeq ($(DERIVATIVE),Ubuntu)
    USAGE_BUILD_DEP = $(EMPTY) python3:any, python3-psutil, python3-matplotlib [!i386],
    ifeq ($(DEB_HOST_ARCH),i386)
      SUMMARY_ONLY = --summary-only
    endif
  else
    USAGE_BUILD_DEP = $(EMPTY) python3:any, python3-psutil [!hurd-i386 !hurd-amd64], python3-matplotlib [!m68k !sh4 !x32 !hurd-i386 !hurd-amd64],
    ifneq (,$(filter $(DEB_HOST_ARCH), hurd-i386 hurd-amd64))
      TIME_COMMAND = $(TIME_BIN) -v
    endif
    ifneq (,$(filter $(DEB_HOST_ARCH), m68k sh4 x32))
      SUMMARY_ONLY = --summary-only
    endif
  endif
endif

DH_VERSION := $(shell dpkg -s debhelper | grep '^Version' | awk '{print $$2}')

include /usr/share/dpkg/architecture.mk

MULTILIB_ARCHS := amd64 i386 mips64 mips64el mipsel powerpc ppc64 s390x sparc sparc64 x32
ifeq ($(DERIVATIVE),Ubuntu)
  ifeq (,$(filter $(DISTRO), bionic focal jammy noble))
    MULTILIB_ARCHS := $(filter-out s390x, $(MULTILIB_ARCHS))
  endif
endif

CONFIGURE_EXTRA =

# these are handled on a per stage / build basis
ifeq ($(VENDOR)-$(DEB_HOST_ARCH),Ubuntu-ppc64el)
  export DEB_CFLAGS_MAINT_STRIP = -g -O3
  export DEB_CXXFLAGS_MAINT_STRIP = -g -O3
else
  export DEB_CFLAGS_MAINT_STRIP = -g -O2
  export DEB_CXXFLAGS_MAINT_STRIP = -g -O2
endif
include /usr/share/dpkg/buildflags.mk

# We use a stage2 build. It means that a first clang is built using gcc,
# a second clang is built with the first
# And the various components are built using the second clang.
# See https://llvm.org/docs/AdvancedBuilds.html

# collect additional flags for all stages all builds
CFLAGS_EXTRA = -Wno-unused-command-line-argument
CXXFLAGS_EXTRA = -Wno-unused-command-line-argument
LDFLAGS_EXTRA = -Wl,--build-id

# collect all flags for stage 1 toolchain build only
STAGE_1_CFLAGS = $(CFLAGS) $(CFLAGS_EXTRA) $(CPPFLAGS)
STAGE_1_CXXFLAGS = $(CXXFLAGS) $(CXXFLAGS_EXTRA) $(CPPFLAGS)
STAGE_1_LDFLAGS = $(LDFLAGS) $(LDFLAGS_EXTRA)
# If we build with libc++, we might want to set different arguments for
# stage 1 & runtimes
RUNTIMES_CFLAGS = $(STAGE_1_CFLAGS)
RUNTIMES_CXXFLAGS := $(STAGE_1_CXXFLAGS)
RUNTIMES_LDFLAGS := $(STAGE_1_LDFLAGS)

# collect all flags for stage 2 toolchain and stand-alone builds
STAGE_2_CFLAGS = $(CFLAGS) $(CFLAGS_EXTRA) $(CPPFLAGS)
STAGE_2_CXXFLAGS = $(CXXFLAGS) $(CXXFLAGS_EXTRA) $(CPPFLAGS)
STAGE_2_LDFLAGS = $(LDFLAGS) $(LDFLAGS_EXTRA)

# collect additional cmake options for toolchain build configuration
STAGE_1_CMAKE_EXTRA =
STAGE_2_CMAKE_EXTRA =
STAGE_ALL_CMAKE_EXTRA =
# toolchain config-only var combining all stage 1 cmake options
CMAKE_EXTRA = $(STAGE_1_CMAKE_EXTRA) $(STAGE_ALL_CMAKE_EXTRA)
# toolchain config-only var prepending BOOTSTRAP_ to all stage 2 cmake options
BOOTSTRAP_CMAKE_EXTRA = $(foreach extra,$(STAGE_2_CMAKE_EXTRA) $(STAGE_ALL_CMAKE_EXTRA), $(subst -D,-DBOOTSTRAP_,$(extra)))

BASE_PATH := $(CURDIR)
STAGE_1_BIN_DIR := $(BASE_PATH)/$(TARGET_BUILD)/bin
STAGE_1_LIB_DIR := $(BASE_PATH)/$(TARGET_BUILD)/lib
STAGE_2_BIN_DIR := $(BASE_PATH)/$(TARGET_BUILD_STAGE2)/bin
STAGE_2_LIB_DIR := $(BASE_PATH)/$(TARGET_BUILD_STAGE2)/lib

# toggleable defaults
COMPILER_RT_USE_BUILTINS_LIBRARY := ON
LIBCXX_EXCEPTIONS := ON
LIBCXX_USE_COMPILER_RT := ON

# We want to set the clang extra version ONLY in stage 2
# because we want the clang stage 1 to be as reproducible as possible
# when building with sccache (because this tool do a hash using the
# compiler binary and other things)
STAGE_2_CMAKE_EXTRA += -DCLANG_REPOSITORY_STRING=$(DEBIAN_REVISION)

ifneq (,$(filter $(DEB_HOST_ARCH),sparc sparc64))
STAGE_1_CMAKE_EXTRA += -DLLVM_PARALLEL_LINK_JOBS=4
endif

ifneq (,$(filter $(DEB_HOST_ARCH),i386 hurd-i386 armel mipsel mips64el powerpc riscv64))
# For some reason, in the stage2 build, when clang is used to compile
# itself. The atomic detection is failing on armel and riscv64. Forcing the inclusion
# everywhere and in all stages
LDFLAGS_EXTRA += -latomic
endif

Z3_FLAG = -DLLVM_ENABLE_Z3_SOLVER=OFF
# no ocaml support in main for Ubuntu
ifneq ($(DERIVATIVE),Ubuntu)

## llvm-toolchain-19 19.1.3

=== debian/changelog ===
llvm-toolchain-19 (1:19.1.3-2) unstable; urgency=medium

  * enable OpenMP (without offloading) on riscv64 (and mips64el and loong64)
    Thanks to Aurélien Jarno for this patch
    (Closes: #1087280)

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 11 Nov 2024 12:45:14 +0100

llvm-toolchain-19 (1:19.1.3-1) unstable; urgency=medium

  * New release

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 30 Oct 2024 21:56:13 +0100

## llvm-toolchain-19 19.1.4

=== clang-tools-extra/clang-change-namespace/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  FrontendOpenMP
  Support
  )

add_clang_library(clangChangeNamespace
  ChangeNamespace.cpp

  DEPENDS
  omp_gen
  ClangDriverOptions
)

clang_target_link_libraries(clangChangeNamespace
  PRIVATE
  clangAST
  clangASTMatchers
  clangBasic
  clangFormat
  clangFrontend
  clangLex
  clangSerialization
  clangTooling
  clangToolingCore
  )

add_subdirectory(tool)

=== compiler-rt/test/lsan/CMakeLists.txt ===
set(LSAN_LIT_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

set(LSAN_TESTSUITES)

set(LSAN_TEST_ARCH ${LSAN_SUPPORTED_ARCH})
if(APPLE)
  darwin_filter_host_archs(LSAN_SUPPORTED_ARCH LSAN_TEST_ARCH)
endif()

foreach(arch ${LSAN_TEST_ARCH})
  set(LSAN_TEST_TARGET_ARCH ${arch})
  string(TOLOWER "-${arch}" LSAN_TEST_CONFIG_SUFFIX)
  get_test_cc_for_arch(${arch} LSAN_TEST_TARGET_CC LSAN_TEST_TARGET_CFLAGS)
  string(TOUPPER ${arch} ARCH_UPPER_CASE)

  set(LSAN_LIT_TEST_MODE "Standalone")
  set(CONFIG_NAME ${ARCH_UPPER_CASE}LsanConfig)
  configure_lit_site_cfg(
    ${CMAKE_CURRENT_SOURCE_DIR}/lit.site.cfg.py.in
    ${CMAKE_CURRENT_BINARY_DIR}/${CONFIG_NAME}/lit.site.cfg.py)
  list(APPEND LSAN_TESTSUITES ${CMAKE_CURRENT_BINARY_DIR}/${CONFIG_NAME})

  list(FIND ASAN_SUPPORTED_ARCH ${arch} _found)
  if(NOT _found EQUAL -1 AND COMPILER_RT_HAS_ASAN)
    set(CONFIG_NAME ${ARCH_UPPER_CASE}AsanConfig)
    set(LSAN_LIT_TEST_MODE "AddressSanitizer")
    configure_lit_site_cfg(
      ${CMAKE_CURRENT_SOURCE_DIR}/lit.site.cfg.py.in
      ${CMAKE_CURRENT_BINARY_DIR}/${CONFIG_NAME}/lit.site.cfg.py)
    list(APPEND LSAN_TESTSUITES ${CMAKE_CURRENT_BINARY_DIR}/${CONFIG_NAME})
  endif()

  list(FIND HWASAN_SUPPORTED_ARCH ${arch} _found)
  if(NOT _found EQUAL -1 AND COMPILER_RT_HAS_HWASAN)
    set(CONFIG_NAME ${ARCH_UPPER_CASE}HWAsanConfig)
    set(LSAN_LIT_TEST_MODE "HWAddressSanitizer")
    configure_lit_site_cfg(
      ${CMAKE_CURRENT_SOURCE_DIR}/lit.site.cfg.py.in
      ${CMAKE_CURRENT_BINARY_DIR}/${CONFIG_NAME}/lit.site.cfg.py)
    list(APPEND LSAN_TESTSUITES ${CMAKE_CURRENT_BINARY_DIR}/${CONFIG_NAME})
  endif()
endforeach()

set(LSAN_TEST_DEPS ${SANITIZER_COMMON_LIT_TEST_DEPS})
list(APPEND LSAN_TEST_DEPS lsan)
append_list_if(COMPILER_RT_HAS_ASAN asan LSAN_TEST_DEPS)
append_list_if(COMPILER_RT_HAS_HWASAN hwasan LSAN_TEST_DEPS)
add_lit_testsuite(check-lsan "Running the LeakSanitizer tests"
  ${LSAN_TESTSUITES}
  DEPENDS ${LSAN_TEST_DEPS})

=== libc/src/sys/wait/CMakeLists.txt ===
if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${LIBC_TARGET_OS})
  add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/${LIBC_TARGET_OS})
endif()

add_entrypoint_object(
  wait
  ALIAS
  DEPENDS
    .${LIBC_TARGET_OS}.wait
)

add_entrypoint_object(
  wait4
  ALIAS
  DEPENDS
    .${LIBC_TARGET_OS}.wait4
)

add_entrypoint_object(
  waitpid
  ALIAS
  DEPENDS
    .${LIBC_TARGET_OS}.waitpid
)

=== lldb/unittests/TestingSupport/Symbol/CMakeLists.txt ===
set_property(DIRECTORY PROPERTY EXCLUDE_FROM_ALL ON)
add_lldb_library(lldbSymbolHelpers
  YAMLModuleTester.cpp

  LINK_LIBS
    lldbCore
    lldbHost
    lldbPluginExpressionParserClang
    lldbPluginObjectFileELF
    lldbPluginSymbolFileDWARF
    lldbPluginTypeSystemClang
    lldbUtilityHelpers
    LLVMTestingSupport

  LINK_COMPONENTS
    ObjectYAML
  )

=== llvm/lib/MC/MCParser/CMakeLists.txt ===
add_llvm_component_library(LLVMMCParser
  AsmLexer.cpp
  AsmParser.cpp
  COFFAsmParser.cpp
  COFFMasmParser.cpp
  GOFFAsmParser.cpp
  DarwinAsmParser.cpp
  ELFAsmParser.cpp
  MCAsmLexer.cpp
  MCAsmParser.cpp
  MCAsmParserExtension.cpp
  MCTargetAsmParser.cpp
  MasmParser.cpp
  WasmAsmParser.cpp
  XCOFFAsmParser.cpp

  ADDITIONAL_HEADER_DIRS
  ${LLVM_MAIN_INCLUDE_DIR}/llvm/MC/MCParser

  LINK_COMPONENTS
  MC
  Support
  TargetParser
  )

=== llvm/lib/Target/VE/MCTargetDesc/CMakeLists.txt ===
add_llvm_component_library(LLVMVEDesc
  VEAsmBackend.cpp
  VEELFObjectWriter.cpp
  VEInstPrinter.cpp
  VEMCAsmInfo.cpp
  VEMCCodeEmitter.cpp
  VEMCExpr.cpp
  VEMCTargetDesc.cpp
  VETargetStreamer.cpp

  LINK_COMPONENTS
  CodeGenTypes
  MC
  Support
  TargetParser
  VEInfo

  ADD_TO_COMPONENT
  VE
  )

=== mlir/test/lib/Dialect/NVGPU/CMakeLists.txt ===
# Exclude tests from libMLIR.so
add_mlir_library(MLIRNVGPUTestPasses
  TestNVGPUTransforms.cpp

  EXCLUDE_FROM_LIBMLIR

  LINK_LIBS PUBLIC
  MLIRIR
  MLIRAffineDialect
  MLIRAnalysis
  MLIRFuncDialect
  MLIRGPUDialect
  MLIRLLVMDialect
  MLIRMemRefDialect
  MLIRNVGPUDialect
  MLIRNVGPUTransforms
  MLIRPass
  MLIRSCFDialect
  MLIRTransformUtils
  )

=== debian/changelog ===
llvm-toolchain-19 (1:19.1.4-1~deb12u1) bookworm; urgency=medium

  * Non-maintainer upload.
  * Rebuild for bookworm.
  * Change build-dep from sid's llvm-spirv-19 to bookworm's llvm-spirv-14.
  * Add python3-myst-parser build-dep.
  * Use CMAKE_BUILD_PARALLEL_LEVEL rather than -j to ensure that we don't
    OOM during builds
    (https://salsa.debian.org/pkg-llvm-team/llvm-toolchain/-/merge_requests/157).

 -- Andres Salomon <dilinger@debian.org>  Wed, 27 Nov 2024 23:40:11 +0000

llvm-toolchain-19 (1:19.1.4-1) unstable; urgency=medium

  [ Sylvestre Ledru ]
  * New upstream release
  * Decrease the risk of getting "hello" as package (instead of installing
    wasi-libc)
    (Closes: #1086702)

  [ Matthias Klose ]
  * d/rules: Add a BD_ALT_HELLO macro. Set it to anything else than "yes" to avoid
    generating alternative build dependencies on hello in the control file.

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 26 Nov 2024 10:14:24 +0100

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
     libipt-dev [amd64 i386],
     lcov, procps, help2man,
     zlib1g-dev, libzstd-dev,
-    g++-multilib [amd64 i386 mips64 mips64el mipsel powerpc ppc64 s390x sparc sparc64 x32] | hello,
+    g++-multilib [amd64 i386 mips64 mips64el mipsel powerpc ppc64 s390x sparc sparc64 x32] | hello [amd64 i386 mips64 mips64el mipsel powerpc ppc64 s390x sparc sparc64 x32],
     libjs-mathjax, python3-myst-parser | python3-recommonmark, python3-pexpect,
     doxygen, time,
     ocaml-base [amd64 arm64 ppc64el riscv64 s390x] | ocaml-nox [amd64 arm64 ppc64el riscv64 s390x],
@@ -24,10 +24,11 @@
     libctypes-ocaml-dev [amd64 arm64 ppc64el riscv64 s390x],
     dh-exec, dh-ocaml [amd64 arm64 ppc64el riscv64 s390x],
     libpfm4-dev [linux-any], python3-setuptools, libz3-dev [!sh4],
+    python3-myst-parser,
 # "| hello" is for older buster/bionic distros without spirv support
 # We need to keep the constraints coherent between the two alternatives, otherwise
 # hello would get installed unexpectedly and prevent e.g. wasi-libc from getting pulled
-    llvm-spirv-19 [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1> | hello [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
+    llvm-spirv-14 [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1> | hello [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
     spirv-tools [linux-any] <!stage1> | hello [linux-any] <!stage1>,
     wasi-libc | hello,
     libcurl4-openssl-dev <!stage1> | libcurl-dev <!stage1>,
@@ -290,6 +291,3 @@
 Section: libdevel
 Depends: ${shlibs:Depends}, ${misc:Depends}, clang-19 (= ${binary:Version})
 Description: Library for coverage-guided fuzz testing
- LibFuzzer is a library for in-process, coverage-guided, evolutionary fuzzing
- of other libraries.
- .

=== debian/rules ===
--- 
+++ 
@@ -64,6 +64,15 @@
   NCPUS := $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
 else
   NCPUS := $(shell nproc)
+endif
+
+# set this macro to anything else than "yes" to avoid generating alternative
+# build dependencies on hello in the control file.
+BD_ALT_HELLO = yes
+ifeq ($(BD_ALT_HELLO),yes)
+  BD_ALT_HELLO_SUBST = 's/@BEGIN_OPTIONAL_HELLO@//g;s/@END_OPTIONAL_HELLO@//g'
+else
+  BD_ALT_HELLO_SUBST = '/@BEGIN_OPTIONAL_HELLO@/,/@END_OPTIONAL_HELLO@/d'
 endif
 
 # this contains all packages to be built. Note that for at least the clean target,
@@ -184,12 +193,3 @@
 endif
 
 ifneq (,$(filter $(DEB_HOST_ARCH),i386 hurd-i386 armel mipsel mips64el powerpc riscv64))
-# For some reason, in the stage2 build, when clang is used to compile
-# itself. The atomic detection is failing on armel and riscv64. Forcing the inclusion
-# everywhere and in all stages
-LDFLAGS_EXTRA += -latomic
-endif
-
-Z3_FLAG = -DLLVM_ENABLE_Z3_SOLVER=OFF
-# no ocaml support in main for Ubuntu
-ifneq ($(DERIVATIVE),Ubuntu)

## llvm-toolchain-19 19.1.5

=== debian/changelog ===
llvm-toolchain-19 (1:19.1.5-1revyos1) unstable; urgency=medium

  * Apply revyos patch

 -- Han Gao <rabenda.cn@gmail.com>  Fri, 13 Dec 2024 15:25:35 +0000

llvm-toolchain-19 (1:19.1.5-1) unstable; urgency=medium

  [ Matthias Klose ]
  * Better correct than less cryptic. Fix BD_ALT_HELLO substitutions.

  [ John Paul Adrian Glaubitz ]
  * Install liborc_rt-powerpc64.a on powerpc

  [ Sylvestre Ledru ]
  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 04 Dec 2024 13:11:08 +0100

=== debian/control ===
--- 
+++ 
@@ -24,11 +24,10 @@
     libctypes-ocaml-dev [amd64 arm64 ppc64el riscv64 s390x],
     dh-exec, dh-ocaml [amd64 arm64 ppc64el riscv64 s390x],
     libpfm4-dev [linux-any], python3-setuptools, libz3-dev [!sh4],
-    python3-myst-parser,
 # "| hello" is for older buster/bionic distros without spirv support
 # We need to keep the constraints coherent between the two alternatives, otherwise
 # hello would get installed unexpectedly and prevent e.g. wasi-libc from getting pulled
-    llvm-spirv-14 [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1> | hello [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
+    llvm-spirv-19 [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1> | hello [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
     spirv-tools [linux-any] <!stage1> | hello [linux-any] <!stage1>,
     wasi-libc | hello,
     libcurl4-openssl-dev <!stage1> | libcurl-dev <!stage1>,
@@ -291,3 +290,5 @@
 Section: libdevel
 Depends: ${shlibs:Depends}, ${misc:Depends}, clang-19 (= ${binary:Version})
 Description: Library for coverage-guided fuzz testing
+ LibFuzzer is a library for in-process, coverage-guided, evolutionary fuzzing
+ of other libraries.

=== debian/rules ===
--- 
+++ 
@@ -72,7 +72,7 @@
 ifeq ($(BD_ALT_HELLO),yes)
   BD_ALT_HELLO_SUBST = 's/@BEGIN_OPTIONAL_HELLO@//g;s/@END_OPTIONAL_HELLO@//g'
 else
-  BD_ALT_HELLO_SUBST = '/@BEGIN_OPTIONAL_HELLO@/,/@END_OPTIONAL_HELLO@/d'
+  BD_ALT_HELLO_SUBST = 's/@BEGIN_OPTIONAL_HELLO@.*@END_OPTIONAL_HELLO@//'
 endif
 
 # this contains all packages to be built. Note that for at least the clean target,

## llvm-toolchain-19 19.1.6

=== debian/changelog ===
llvm-toolchain-19 (1:19.1.6-1ubuntu1) plucky; urgency=medium

  * Merge with Debian; remaining changes:
   - Unset BD_ALT_HELLO.
   - Regenerate the control file.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 18 Dec 2024 19:16:32 +0100

llvm-toolchain-19 (1:19.1.6-1) unstable; urgency=medium

  [ Sylvestre Ledru ]
  * New upstream release. Should be the last of 19
    And the one in the next Debian release
  * Remove the capability to be able to disable C++ Exceptions in libc++
  * Bring back C++ exceptions on s390x for libc++ (LP: #2086782)
  * Disable -Bsymbolic-function on Ubuntu for causing:
    https://github.com/llvm/llvm-project/issues/59432#issuecomment-2500694332

  [ Matthias Klose ]
  * bolt: Disable the check for /proc/self/map_files. Might not be available
    on build machines. LP: #2084316.
  * Fix compatibility with Python 3.13. Closes: #1084638.

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 18 Dec 2024 10:01:43 +0100

llvm-toolchain-19 (1:19.1.5-1ubuntu1) plucky; urgency=medium

  * Merge with Debian; remaining changes:
   - Unset BD_ALT_HELLO.
   - Regenerate the control file.

   [ Sylvestre Ledru ]
   * Remove the capability to be able to disable C++ Exceptions in libc++
   * Bring back C++ exceptions on s390x for libc++ (LP: #2086782)

 -- Matthias Klose <doko@ubuntu.com>  Fri, 13 Dec 2024 10:40:30 +0100

llvm-toolchain-19 (1:19.1.4-1ubuntu1) plucky; urgency=medium

  * Merge with Debian; remaining changes:
   - Unset BD_ALT_HELLO.
   - Regenerate the control file.
  * Better correct than less cryptic. Fix BD_ALT_HELLO substitutions.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 27 Nov 2024 10:34:52 +0100

llvm-toolchain-19 (1:19.1.3-2ubuntu2) plucky; urgency=medium

  [ Matthias Klose ]
  * d/rules: Add a BD_ALT_HELLO macro. Set it to anything else than "yes" to avoid
    generating alternative build dependencies on hello in the control file.
  * Unset BD_ALT_HELLO.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 13 Nov 2024 11:41:00 +0100

=== debian/control ===
--- 
+++ 
@@ -16,20 +16,20 @@
     libipt-dev [amd64 i386],
     lcov, procps, help2man,
     zlib1g-dev, libzstd-dev,
-    g++-multilib [amd64 i386 mips64 mips64el mipsel powerpc ppc64 s390x sparc sparc64 x32] | hello [amd64 i386 mips64 mips64el mipsel powerpc ppc64 s390x sparc sparc64 x32],
+    g++-multilib [amd64 i386 mips64 mips64el mipsel powerpc ppc64 sparc sparc64 x32],
     libjs-mathjax, python3-myst-parser | python3-recommonmark, python3-pexpect,
     doxygen, time,
     ocaml-base [amd64 arm64 ppc64el riscv64 s390x] | ocaml-nox [amd64 arm64 ppc64el riscv64 s390x],
     ocaml-findlib [amd64 arm64 ppc64el riscv64 s390x],
     libctypes-ocaml-dev [amd64 arm64 ppc64el riscv64 s390x],
     dh-exec, dh-ocaml [amd64 arm64 ppc64el riscv64 s390x],
-    libpfm4-dev [linux-any], python3-setuptools, libz3-dev [!sh4],
+    libpfm4-dev [linux-any], python3-setuptools, 
 # "| hello" is for older buster/bionic distros without spirv support
 # We need to keep the constraints coherent between the two alternatives, otherwise
 # hello would get installed unexpectedly and prevent e.g. wasi-libc from getting pulled
-    llvm-spirv-19 [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1> | hello [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
-    spirv-tools [linux-any] <!stage1> | hello [linux-any] <!stage1>,
-    wasi-libc | hello,
+    llvm-spirv-19 [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
+    spirv-tools [linux-any] <!stage1>,
+    wasi-libc,
     libcurl4-openssl-dev <!stage1> | libcurl-dev <!stage1>,
     libgrpc++-dev [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x] <!stage1>,
     protobuf-compiler-grpc [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x] <!stage1>,
@@ -292,3 +292,6 @@
 Description: Library for coverage-guided fuzz testing
  LibFuzzer is a library for in-process, coverage-guided, evolutionary fuzzing
  of other libraries.
+ .
+ LibFuzzer is similar in concept to American Fuzzy Lop (AFL), but it performs
+ all of its fuzzing inside a single process. This in-process fuzzing can be
